local SmartCast_Res=nil;
local tonumber=tonumber
local _

function HealBot_Init_retSmartCast_Res()
    return SmartCast_Res
end

function HealBot_InitGetSpellData(spell)

    if ( not spell ) then return end
    
   -- name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange 
    local _, _, _, HB_mana, _, _, msCast, _, _ = GetSpellInfo(spell)

    local hbCastTime=tonumber(msCast or 0);
    if hbCastTime>999 then hbCastTime=HealBot_Comm_round(hbCastTime/1000,2) end
    HealBot_Spells[spell].CastTime=hbCastTime;
    if HB_mana then
        HealBot_Spells[spell].Mana=tonumber(HB_mana);
    end
    HealBot_InitClearSpellNils(spell)
end

function HealBot_InitClearSpellNils(spell)
    if not HealBot_Spells[spell].CastTime then
        HealBot_Spells[spell].CastTime=0;
    end
    if not HealBot_Spells[spell].Mana then
        HealBot_Spells[spell].Mana=10*UnitLevel("player");
    end
end

function HealBot_FindSpellRangeCast(id, spellName)

    if ( not id ) then return nil; end

    local spell, _, _, HB_mana, _, _, msCast, _, _ = HealBot_GetSpellName(id);
    if ( not spell ) then return nil; end
    if not spellName then spellName=spell end
    
    if spell==HEALBOT_HOLY_WORD_SERENITY then 
        id=HealBot_GetSpellId(HEALBOT_HOLY_WORD_CHASTISE)
        _, _, _, HB_mana, _, _, msCast, _, _ = HealBot_GetSpellName(id);
    end
    
    local hbCastTime=tonumber(msCast or 0);
    if hbCastTime>999 then hbCastTime=HealBot_Comm_round(hbCastTime/1000,2) end
    
    HealBot_Spells[spellName]={}
    HealBot_InitClearSpellNils(spellName)
    HealBot_Spells[spellName].CastTime=hbCastTime;
    if not HB_mana then
        HealBot_Spells[spellName].Mana=50*UnitLevel("player");
    else
        HealBot_Spells[spellName].Mana=tonumber(HB_mana);
    end
    return true
end

function HealBot_Init_Spells_Defaults()
    local i = GetSpecialization()
    local specID = 0
    if i then
        specID = GetSpecializationInfo(i,false,false) 
    end
    HealBot_Spells={}
    
    local nTabs=GetNumSpellTabs()
    for j=1,nTabs do
        local name, texture, offset, numEntries, isGuild, offspecID = GetSpellTabInfo(j)
        if offspecID==0 then
            for s=1,numEntries do
                local sName, sSubtext = GetSpellBookItemName(s, BOOKTYPE_SPELL)
                local sType, sId = GetSpellBookItemInfo(s, BOOKTYPE_SPELL)
                if sType == "SPELL" and not IsPassiveSpell(sId) then
                    HealBot_Init_Spells_addSpell(sId, sName, sSubtext)
                elseif spellType == "FLYOUT" then
                    local _, _, numFlyoutSlots, flyoutKnown = GetFlyoutInfo(sId)
                    for f=1,numFlyoutSlots do
                        local fId, _, fKnown, fName = GetFlyoutSlotInfo(sId, f)
                        if fKnown then
                            HealBot_Init_Spells_addSpell(fId, fName, sSubtext)
                        end
                    end
                end
            end
        end
    end
    if HealBot_Data["PCLASSTRIM"]==HealBot_Class_En[HEALBOT_SHAMAN] then
        if specID==262 then  -- Elemental
        elseif specID==263 then  -- Enhancement
        elseif specID==264 then -- Restoration
            if HealBot_FindSpellRangeCast(77130, HEALBOT_PURIFY_SPIRIT) then
                HealBot_Spells[HEALBOT_PURIFY_SPIRIT].id=77130
            end
        end
    elseif HealBot_Data["PCLASSTRIM"]==HealBot_Class_En[HEALBOT_MONK] then
        if specID==268 then  -- Brewmaster
        elseif specID==269 then  -- Windwalker
        elseif specID==270 then  -- Mistweaver
        end
    elseif HealBot_Data["PCLASSTRIM"]==HealBot_Class_En[HEALBOT_PRIEST] then
        if specID==256 then -- Disp
        elseif specID==257 then -- Holy
            if HealBot_FindSpellRangeCast(88684, HEALBOT_HOLY_WORD_SERENITY) then
                HealBot_Spells[HEALBOT_HOLY_WORD_SERENITY].id=88684
            end
        elseif specID==258 then -- Shadow
        end
    end
end

function HealBot_Init_Spells_addSpell(spellId, spellName,spellSubtext)
    if HealBot_FindSpellRangeCast(spellId, spellName) then
        HealBot_Spells[spellName].id=spellId
    end
end

function HealBot_Init_SmartCast()
    if HealBot_Data["PCLASSTRIM"]=="PRIE" then
        SmartCast_Res=HEALBOT_RESURRECTION;
    elseif HealBot_Data["PCLASSTRIM"]=="DRUI" then
        SmartCast_Res=HEALBOT_REVIVE;
    elseif HealBot_Data["PCLASSTRIM"]=="MONK" then
        SmartCast_Res=HEALBOT_RESUSCITATE;
    elseif HealBot_Data["PCLASSTRIM"]=="PALA" then
        SmartCast_Res=HEALBOT_REDEMPTION;
    elseif HealBot_Data["PCLASSTRIM"]=="SHAM" then
        SmartCast_Res=HEALBOT_ANCESTRALSPIRIT;
    end
end
